"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactTransitionGroup = require("react-transition-group");

var _styledSystem = require("styled-system");

var _dialog = require("@reach/dialog");

var _pclnDesignSystem = require("pcln-design-system");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _templateObject8() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  position: relative;\n  height: 100%;\n"]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  display: table-cell;\n  vertical-align: ", ";\n  ", ";\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  display: table;\n  height: 100%;\n  width: 100%;\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  position: relative;\n  ", "\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  position: absolute;\n  top: 16px;\n  right: 16px;\n  z-index: 2;\n\n  svg {\n    vertical-align: top;\n  }\n\n  &:focus {\n    background-color: ", ";\n    outline: none;\n  }\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  flex-shrink: 0;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  ", " \n  ", "\n  ", "\n  max-width: calc(100vw - 32px);\n  position: relative;\n  margin-left: auto;\n  margin-right: auto;\n  box-shadow: ", ";\n  &:focus {\n    outline: none;\n  }\n  max-height: 100vh;\n  ", "\n  ", "\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  background-color: rgba(0, 0, 0, 0.7);\n  bottom: 0;\n  left: 0;\n  overflow-y: auto;\n  position: fixed;\n  right: 0;\n  top: 0;\n  ", "\n  * {\n    box-sizing: border-box;\n  }\n  ", ";\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var OVERLAY_ANIMATION = function OVERLAY_ANIMATION(transitionState) {
  return "\n  opacity: 0;\n  transition: opacity .5s cubic-bezier(0.50, 0.00, 0.25, 1.00);\n  ".concat(transitionState === 'entering' ? "opacity: 0;" : '', "\n  ").concat(transitionState === 'entered' ? "opacity: 1;" : '', "\n  ").concat(transitionState === 'exiting' ? "opacity: 0;" : '', "\n  ").concat(transitionState === 'exited' ? "opacity: 0;" : '', "\n");
};

var DIALOG_ANIMATION = function DIALOG_ANIMATION(transitionState) {
  return "\n  transform: scale(0.5);\n  transition: transform .5s cubic-bezier(0.50, 0.00, 0.25, 1.00);\n  ".concat(transitionState === 'entering' ? "transform: scale(0.5);" : '', "\n  ").concat(transitionState === 'entered' ? "transform: scale(1);" : '', "\n  ").concat(transitionState === 'exiting' ? "transform: scale(0.5);" : '', "\n  ").concat(transitionState === 'exited' ? "transform: scale(0.5);" : '', "\n");
};

var getAnimation = function getAnimation(_ref) {
  var transitionstate = _ref.transitionstate,
      defaultAnimation = _ref.defaultAnimation,
      _ref$customAnimation = _ref.customAnimation,
      customAnimation = _ref$customAnimation === void 0 ? null : _ref$customAnimation;
  return typeof customAnimation === 'function' ? customAnimation(transitionstate) : defaultAnimation(transitionstate);
};

var Overlay = (0, _styledComponents["default"])(_dialog.DialogOverlay)(_templateObject(), function (props) {
  var _props$theme$lineHeig, _props$theme$fontWeig;

  return "\n    z-index: ".concat(props.zindex || 100, ";\n    font-family: ").concat(props.theme.font, ";\n    line-height: ").concat((_props$theme$lineHeig = props.theme.lineHeights) === null || _props$theme$lineHeig === void 0 ? void 0 : _props$theme$lineHeig.standard, ";\n    font-weight: ").concat((_props$theme$fontWeig = props.theme.fontWeights) === null || _props$theme$fontWeig === void 0 ? void 0 : _props$theme$fontWeig.medium, ";\n  ");
}, getAnimation);
var Dialog = (0, _styledComponents["default"])(_dialog.DialogContent)(_templateObject2(), _styledSystem.color, _styledSystem.width, _styledSystem.height, function (props) {
  return props.theme.boxShadows[3];
}, function (props) {
  return props.enableoverflow && "\n    max-height: none;\n  ";
}, getAnimation);

var HeaderWrapper = _styledComponents["default"].div(_templateObject3());

var FloatCloseButton = (0, _styledComponents["default"])(_pclnDesignSystem.CloseButton)(_templateObject4(), function (props) {
  return props.theme.colors.borderGray;
});
var ContentWrapper = (0, _styledComponents["default"])(_pclnDesignSystem.Box)(_templateObject5(), function (props) {
  if (!props.enableoverflow) {
    return "\n        overflow-y: scroll;\n        overflow-x: hidden;\n        height: 100%;\n        -webkit-overflow-scrolling: touch;\n      ";
  }
});

var OverlayWrapper = _styledComponents["default"].div(_templateObject6());

var DialogWrapper = (0, _styledComponents["default"])(_pclnDesignSystem.Box)(_templateObject7(), function (_ref2) {
  var verticalAlignment = _ref2.verticalAlignment;
  return verticalAlignment;
}, function (props) {
  return props.enableoverflow && "\n    padding-top: 24px;\n    padding-bottom: 24px;\n  ";
});
var DialogInnerWrapper = (0, _styledComponents["default"])(_pclnDesignSystem.Flex)(_templateObject8());

var Modal = function Modal(_ref3) {
  var isOpen = _ref3.isOpen,
      onClose = _ref3.onClose,
      bg = _ref3.bg,
      zIndex = _ref3.zIndex,
      children = _ref3.children,
      imgMode = _ref3.imgMode,
      width = _ref3.width,
      className = _ref3.className,
      header = _ref3.header,
      disableCloseButton = _ref3.disableCloseButton,
      enableOverflow = _ref3.enableOverflow,
      height = _ref3.height,
      dialogAnimation = _ref3.dialogAnimation,
      overlayAnimation = _ref3.overlayAnimation,
      verticalAlignment = _ref3.verticalAlignment;
  return _react["default"].createElement(_reactTransitionGroup.Transition, {
    "in": isOpen,
    unmountOnExit: true,
    timeout: 500
  }, function (state) {
    return _react["default"].createElement(Overlay, {
      onDismiss: onClose,
      zindex: zIndex,
      transitionstate: state,
      initialFocusRef: null,
      defaultAnimation: OVERLAY_ANIMATION,
      customAnimation: overlayAnimation
    }, _react["default"].createElement(OverlayWrapper, null, _react["default"].createElement(DialogWrapper, {
      enableoverflow: enableOverflow,
      verticalAlignment: verticalAlignment
    }, _react["default"].createElement(Dialog, {
      width: width,
      bg: bg,
      height: enableOverflow ? null : height,
      transitionstate: state,
      className: className,
      enableoverflow: enableOverflow ? 'true' : null,
      defaultAnimation: DIALOG_ANIMATION,
      customAnimation: dialogAnimation
    }, _react["default"].createElement(DialogInnerWrapper, {
      flexDirection: "column"
    }, header && _react["default"].createElement(HeaderWrapper, null, header), _react["default"].createElement(ContentWrapper, {
      p: imgMode ? 0 : 16,
      header: header,
      enableoverflow: enableOverflow
    }, enableOverflow && !disableCloseButton && _react["default"].createElement(FloatCloseButton, {
      "data-testid": "pcln-modal-close",
      header: header,
      onClick: onClose
    }), children))))));
  });
};

Modal.defaultProps = {
  isOpen: false,
  disableCloseButton: false,
  enableOverflow: false,
  header: null,
  bg: 'white',
  height: 420,
  overlayAnimation: null,
  dialogAnimation: null,
  verticalAlignment: 'middle'
};
Modal.propTypes = _objectSpread({}, _styledSystem.width.propTypes, {}, _styledSystem.height.propTypes, {
  isOpen: _propTypes["default"].bool,
  disableCloseButton: _propTypes["default"].bool,
  enableOverflow: _propTypes["default"].bool,
  onClose: _propTypes["default"].func,
  bg: (0, _pclnDesignSystem.deprecatedPropType)('color'),
  zIndex: _propTypes["default"].number,
  title: _propTypes["default"].string,
  headerBg: _propTypes["default"].string,
  imgMode: _propTypes["default"].bool,
  className: _propTypes["default"].string,
  header: _propTypes["default"].any,
  overlayAnimation: _propTypes["default"].func,
  dialogAnimation: _propTypes["default"].func,
  verticalAlignment: _propTypes["default"].string
});
var _default = Modal;
exports["default"] = _default;