"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var ScrollLock =
/*#__PURE__*/
function () {
  function ScrollLock() {
    (0, _classCallCheck2["default"])(this, ScrollLock);
    this.currentPos = 0;
    this.tag = null;
    this.head = document.head;
  }

  (0, _createClass2["default"])(ScrollLock, [{
    key: "getCurrentPos",
    value: function getCurrentPos() {
      return window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop;
    }
  }, {
    key: "createStyleTag",
    value: function createStyleTag() {
      var css = "\n      body {\n        overflow: hidden !important;\n        position: fixed;\n        top: -".concat(this.currentPos, "px;\n        left: 0;\n        width: 100%;\n      }\n    ");
      var tag = document.createElement('style');
      tag.type = 'text/css';
      tag.setAttribute('data-react-scrolllock', '');
      tag.appendChild(document.createTextNode(css));
      this.head.appendChild(tag);
      this.tag = tag;
    }
  }, {
    key: "on",
    value: function on() {
      if (!this.head) return;
      this.currentPos = this.getCurrentPos();
      this.createStyleTag();
    }
  }, {
    key: "off",
    value: function off() {
      if (!this.tag) return;
      this.head.removeChild(this.tag);
      this.tag = null;
      window.scrollTo(0, this.currentPos);
    }
  }]);
  return ScrollLock;
}();

exports["default"] = ScrollLock;